<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>GlobalExceptionHandler.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">vendingmachine</a> &gt; <a href="index.source.html" class="el_package">com.example.vendingmachine.exception</a> &gt; <span class="el_source">GlobalExceptionHandler.java</span></div><h1>GlobalExceptionHandler.java</h1><pre class="source lang-java linenums">package com.example.vendingmachine.exception;

import java.util.Date;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatusCode;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.MethodArgumentNotValidException;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.context.request.WebRequest;
import org.springframework.web.servlet.mvc.method.annotation.ResponseEntityExceptionHandler;

@ControllerAdvice
<span class="fc" id="L17">public class GlobalExceptionHandler extends ResponseEntityExceptionHandler {</span>

    // error handle for @Valid
    @Override
    protected ResponseEntity&lt;Object&gt; handleMethodArgumentNotValid(MethodArgumentNotValidException ex,
            HttpHeaders headers, HttpStatusCode status, WebRequest request) {

<span class="fc" id="L24">        Map&lt;String, Object&gt; body = new LinkedHashMap&lt;&gt;();</span>
<span class="fc" id="L25">        body.put(&quot;timestamp&quot;, new Date());</span>
<span class="fc" id="L26">        body.put(&quot;status&quot;, status.value());</span>

<span class="fc" id="L28">        List&lt;String&gt; errors = ex.getBindingResult()</span>
<span class="fc" id="L29">                .getFieldErrors()</span>
<span class="fc" id="L30">                .stream()</span>
<span class="fc" id="L31">                .map(x -&gt; x.getDefaultMessage())</span>
<span class="fc" id="L32">                .collect(Collectors.toList());</span>

<span class="fc" id="L34">        body.put(&quot;errors&quot;, errors);</span>

<span class="fc" id="L36">        return new ResponseEntity&lt;Object&gt;(body, headers, status);</span>

    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.8.202204050719</span></div></body></html>